#include <iostream>
#include <map>
#include <utility>
#include <string>

using namespace std;

typedef long long int64;
typedef pair<int64,int64> ulamek;

int max_id,cnt1,cnt2;
char name1[1000],name2[1000];
ulamek s[10][10];
map<string,int> id;
bool b[10];

void dfs(int x,int from,ulamek current) {
  if (b[x])
    return;
  b[x]=true;
  s[from][x]=current;
  for (int i=0; i<max_id; i++)
    if (!b[i] && s[from][i].first>=0)
      dfs(i,from,ulamek(current.first*s[from][i].first,current.second*s[from][i].second));
}

int find_id(const char *t) {
  if (!id.count(t))
    id[t]=max_id++;
  return id[t];
}

int main() {
  int t,p,i,j,w;

  scanf("%d",&t);
  while (t--) {
    scanf("%d",&p);
    id.clear();
    max_id=0;
    for (i=0; i<10; i++)
      for (j=0; j<10; j++)
        s[i][j].first=-1;
    for (i=0; i<p; i++) {
      scanf("%d %s = %d %s",&cnt1,name1,&cnt2,name2);
      s[find_id(name1)][find_id(name2)]=ulamek(cnt2,cnt1);
      s[find_id(name2)][find_id(name1)]=ulamek(cnt1,cnt2);
    }
    for (i=0; i<max_id; i++) {
      for (j=0; j<max_id; j++)
        b[j]=false;
      dfs(i,i,ulamek(1,1));
    }
    scanf("%d",&w);
    while (w--) {
      scanf("%d %s",&i,name1);
    }
  }

  return 0;
}
