#include <cstdio>

#define MAX 50000

int n,t[MAX],partial[MAX];
bool winning[8][MAX];

bool solve() {
  int i,j,k,s,second,ri,rii,jj;

  partial[0]=0;
  for (i=1; i<=n; i++)
    partial[i]=partial[i-1]+t[i];
  s=partial[n];
  for (i=0; i<s; i++)
    winning[0][i]=false;
  for (i=1; i<=n; i++) {
    ri=(i&7);
    for (j=0; j<s/2; j++) {
      winning[ri][j]=false;
      second=s-partial[i]-j;
      if (second>=0 && second<s/2) {
	jj=j+t[i];
	rii=ri;
	for (k=1; k<=4 && k<=i && jj<s/2; k++) {
	  if (--rii<0)
	    rii=7;
	  if (!winning[rii][second])
	    winning[ri][j]=true;
	  jj+=t[i-k];
	}
	if (k<=4 && k<=i && jj==s/2)
	  winning[ri][j]=true;
      }
    }
  }

  return winning[n&7][0];
}

int main() {
  int d,i;
  
  scanf("%d",&d);
  while (d--) {
    scanf("%d",&n);
    for (i=0; i<n; i++)
      scanf("%d",&t[n-i]);
    printf(solve()?"TAK\n":"NIE\n");
  }

  return 0;
}
